/******/ (() => { // webpackBootstrap
/******/ 	"use strict";

// UNUSED EXPORTS: ipc

;// external "electron"
const external_electron_namespaceObject = require("electron");
;// ./src/auth/preload.ts

/* harmony default export */ const preload = ({
    getHcaptchaAccessibilityCookie: () => external_electron_namespaceObject.ipcRenderer.invoke("getCookie", { url: "https://www.hcaptcha.com/", name: "hc_accessibility" }),
    loginRequest: (alertTitle, alertBody, buttonText) => external_electron_namespaceObject.ipcRenderer.invoke("loginRequest", {
        alertTitle,
        alertBody,
        buttonText,
    }),
});

;// ../../libs/common/src/platform/enums/encryption-type.enum.ts
var EncryptionType;
(function (EncryptionType) {
    EncryptionType[EncryptionType["AesCbc256_B64"] = 0] = "AesCbc256_B64";
    EncryptionType[EncryptionType["AesCbc128_HmacSha256_B64"] = 1] = "AesCbc128_HmacSha256_B64";
    EncryptionType[EncryptionType["AesCbc256_HmacSha256_B64"] = 2] = "AesCbc256_HmacSha256_B64";
    EncryptionType[EncryptionType["Rsa2048_OaepSha256_B64"] = 3] = "Rsa2048_OaepSha256_B64";
    EncryptionType[EncryptionType["Rsa2048_OaepSha1_B64"] = 4] = "Rsa2048_OaepSha1_B64";
    EncryptionType[EncryptionType["Rsa2048_OaepSha256_HmacSha256_B64"] = 5] = "Rsa2048_OaepSha256_HmacSha256_B64";
    EncryptionType[EncryptionType["Rsa2048_OaepSha1_HmacSha256_B64"] = 6] = "Rsa2048_OaepSha1_HmacSha256_B64";
})(EncryptionType || (EncryptionType = {}));
function encryptionTypeToString(encryptionType) {
    if (encryptionType in EncryptionType) {
        return EncryptionType[encryptionType];
    }
    else {
        return "Unknown encryption type " + encryptionType;
    }
}
const EXPECTED_NUM_PARTS_BY_ENCRYPTION_TYPE = {
    [EncryptionType.AesCbc256_B64]: 2,
    [EncryptionType.AesCbc128_HmacSha256_B64]: 3,
    [EncryptionType.AesCbc256_HmacSha256_B64]: 3,
    [EncryptionType.Rsa2048_OaepSha256_B64]: 1,
    [EncryptionType.Rsa2048_OaepSha1_B64]: 1,
    [EncryptionType.Rsa2048_OaepSha256_HmacSha256_B64]: 2,
    [EncryptionType.Rsa2048_OaepSha1_HmacSha256_B64]: 2,
};

;// ../../libs/common/src/platform/enums/file-upload-type.enum.ts
var FileUploadType;
(function (FileUploadType) {
    FileUploadType[FileUploadType["Direct"] = 0] = "Direct";
    FileUploadType[FileUploadType["Azure"] = 1] = "Azure";
})(FileUploadType || (FileUploadType = {}));

;// ../../libs/common/src/platform/enums/hash-purpose.enum.ts
var HashPurpose;
(function (HashPurpose) {
    HashPurpose[HashPurpose["ServerAuthorization"] = 1] = "ServerAuthorization";
    HashPurpose[HashPurpose["LocalAuthorization"] = 2] = "LocalAuthorization";
})(HashPurpose || (HashPurpose = {}));

;// ../../libs/common/src/platform/enums/html-storage-location.enum.ts
var HtmlStorageLocation;
(function (HtmlStorageLocation) {
    HtmlStorageLocation["Local"] = "local";
    HtmlStorageLocation["Memory"] = "memory";
    HtmlStorageLocation["Session"] = "session";
})(HtmlStorageLocation || (HtmlStorageLocation = {}));

;// ../../libs/common/src/platform/enums/key-suffix-options.enum.ts
var KeySuffixOptions;
(function (KeySuffixOptions) {
    KeySuffixOptions["Auto"] = "auto";
    KeySuffixOptions["Biometric"] = "biometric";
    KeySuffixOptions["Pin"] = "pin";
})(KeySuffixOptions || (KeySuffixOptions = {}));

;// ../../libs/common/src/platform/enums/log-level-type.enum.ts
var LogLevelType;
(function (LogLevelType) {
    LogLevelType[LogLevelType["Debug"] = 0] = "Debug";
    LogLevelType[LogLevelType["Info"] = 1] = "Info";
    LogLevelType[LogLevelType["Warning"] = 2] = "Warning";
    LogLevelType[LogLevelType["Error"] = 3] = "Error";
})(LogLevelType || (LogLevelType = {}));

;// ../../libs/common/src/platform/enums/storage-location.enum.ts
var StorageLocation;
(function (StorageLocation) {
    StorageLocation["Both"] = "both";
    StorageLocation["Disk"] = "disk";
    StorageLocation["Memory"] = "memory";
})(StorageLocation || (StorageLocation = {}));

;// ../../libs/common/src/platform/enums/theme-type.enum.ts
var ThemeType;
(function (ThemeType) {
    ThemeType["System"] = "system";
    ThemeType["Light"] = "light";
    ThemeType["Dark"] = "dark";
    ThemeType["Nord"] = "nord";
    ThemeType["SolarizedDark"] = "solarizedDark";
})(ThemeType || (ThemeType = {}));
const ThemeTypes = {
    System: "system",
    Light: "light",
    Dark: "dark",
    Nord: "nord",
    SolarizedDark: "solarizedDark",
};

;// ../../libs/common/src/platform/enums/index.ts









;// ./src/types/biometric-message.ts
var BiometricAction;
(function (BiometricAction) {
    BiometricAction["EnabledForUser"] = "enabled";
    BiometricAction["OsSupported"] = "osSupported";
    BiometricAction["Authenticate"] = "authenticate";
    BiometricAction["NeedsSetup"] = "needsSetup";
    BiometricAction["Setup"] = "setup";
    BiometricAction["CanAutoSetup"] = "canAutoSetup";
})(BiometricAction || (BiometricAction = {}));

;// ./src/key-management/preload.ts



const biometric = {
    enabled: (userId) => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.EnabledForUser,
        key: `${userId}_user_biometric`,
        keySuffix: KeySuffixOptions.Biometric,
        userId: userId,
    }),
    osSupported: () => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.OsSupported,
    }),
    biometricsNeedsSetup: () => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.NeedsSetup,
    }),
    biometricsSetup: () => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.Setup,
    }),
    biometricsCanAutoSetup: () => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.CanAutoSetup,
    }),
    authenticate: () => external_electron_namespaceObject.ipcRenderer.invoke("biometric", {
        action: BiometricAction.Authenticate,
    }),
};
/* harmony default export */ const key_management_preload = ({
    biometric,
});

;// ../../libs/common/src/enums/client-type.enum.ts
var ClientType;
(function (ClientType) {
    ClientType["Web"] = "web";
    ClientType["Browser"] = "browser";
    ClientType["Desktop"] = "desktop";
    ClientType["Cli"] = "cli";
})(ClientType || (ClientType = {}));

;// ../../libs/common/src/enums/device-type.enum.ts
var DeviceType;
(function (DeviceType) {
    DeviceType[DeviceType["Android"] = 0] = "Android";
    DeviceType[DeviceType["iOS"] = 1] = "iOS";
    DeviceType[DeviceType["ChromeExtension"] = 2] = "ChromeExtension";
    DeviceType[DeviceType["FirefoxExtension"] = 3] = "FirefoxExtension";
    DeviceType[DeviceType["OperaExtension"] = 4] = "OperaExtension";
    DeviceType[DeviceType["EdgeExtension"] = 5] = "EdgeExtension";
    DeviceType[DeviceType["WindowsDesktop"] = 6] = "WindowsDesktop";
    DeviceType[DeviceType["MacOsDesktop"] = 7] = "MacOsDesktop";
    DeviceType[DeviceType["LinuxDesktop"] = 8] = "LinuxDesktop";
    DeviceType[DeviceType["ChromeBrowser"] = 9] = "ChromeBrowser";
    DeviceType[DeviceType["FirefoxBrowser"] = 10] = "FirefoxBrowser";
    DeviceType[DeviceType["OperaBrowser"] = 11] = "OperaBrowser";
    DeviceType[DeviceType["EdgeBrowser"] = 12] = "EdgeBrowser";
    DeviceType[DeviceType["IEBrowser"] = 13] = "IEBrowser";
    DeviceType[DeviceType["UnknownBrowser"] = 14] = "UnknownBrowser";
    DeviceType[DeviceType["AndroidAmazon"] = 15] = "AndroidAmazon";
    DeviceType[DeviceType["UWP"] = 16] = "UWP";
    DeviceType[DeviceType["SafariBrowser"] = 17] = "SafariBrowser";
    DeviceType[DeviceType["VivaldiBrowser"] = 18] = "VivaldiBrowser";
    DeviceType[DeviceType["VivaldiExtension"] = 19] = "VivaldiExtension";
    DeviceType[DeviceType["SafariExtension"] = 20] = "SafariExtension";
    DeviceType[DeviceType["SDK"] = 21] = "SDK";
    DeviceType[DeviceType["Server"] = 22] = "Server";
    DeviceType[DeviceType["WindowsCLI"] = 23] = "WindowsCLI";
    DeviceType[DeviceType["MacOsCLI"] = 24] = "MacOsCLI";
    DeviceType[DeviceType["LinuxCLI"] = 25] = "LinuxCLI";
})(DeviceType || (DeviceType = {}));
const MobileDeviceTypes = new Set([
    DeviceType.Android,
    DeviceType.iOS,
    DeviceType.AndroidAmazon,
]);
const DesktopDeviceTypes = new Set([
    DeviceType.WindowsDesktop,
    DeviceType.MacOsDesktop,
    DeviceType.LinuxDesktop,
    DeviceType.UWP,
    DeviceType.WindowsCLI,
    DeviceType.MacOsCLI,
    DeviceType.LinuxCLI,
]);

;// ../../libs/common/src/enums/event-system-user.enum.ts
var EventSystemUser;
(function (EventSystemUser) {
    EventSystemUser[EventSystemUser["SCIM"] = 1] = "SCIM";
    EventSystemUser[EventSystemUser["DomainVerification"] = 2] = "DomainVerification";
    EventSystemUser[EventSystemUser["PublicApi"] = 3] = "PublicApi";
})(EventSystemUser || (EventSystemUser = {}));

;// ../../libs/common/src/enums/event-type.enum.ts
var EventType;
(function (EventType) {
    EventType[EventType["User_LoggedIn"] = 1000] = "User_LoggedIn";
    EventType[EventType["User_ChangedPassword"] = 1001] = "User_ChangedPassword";
    EventType[EventType["User_Updated2fa"] = 1002] = "User_Updated2fa";
    EventType[EventType["User_Disabled2fa"] = 1003] = "User_Disabled2fa";
    EventType[EventType["User_Recovered2fa"] = 1004] = "User_Recovered2fa";
    EventType[EventType["User_FailedLogIn"] = 1005] = "User_FailedLogIn";
    EventType[EventType["User_FailedLogIn2fa"] = 1006] = "User_FailedLogIn2fa";
    EventType[EventType["User_ClientExportedVault"] = 1007] = "User_ClientExportedVault";
    EventType[EventType["User_UpdatedTempPassword"] = 1008] = "User_UpdatedTempPassword";
    EventType[EventType["User_MigratedKeyToKeyConnector"] = 1009] = "User_MigratedKeyToKeyConnector";
    EventType[EventType["User_RequestedDeviceApproval"] = 1010] = "User_RequestedDeviceApproval";
    EventType[EventType["User_TdeOffboardingPasswordSet"] = 1011] = "User_TdeOffboardingPasswordSet";
    EventType[EventType["Cipher_Created"] = 1100] = "Cipher_Created";
    EventType[EventType["Cipher_Updated"] = 1101] = "Cipher_Updated";
    EventType[EventType["Cipher_Deleted"] = 1102] = "Cipher_Deleted";
    EventType[EventType["Cipher_AttachmentCreated"] = 1103] = "Cipher_AttachmentCreated";
    EventType[EventType["Cipher_AttachmentDeleted"] = 1104] = "Cipher_AttachmentDeleted";
    EventType[EventType["Cipher_Shared"] = 1105] = "Cipher_Shared";
    EventType[EventType["Cipher_UpdatedCollections"] = 1106] = "Cipher_UpdatedCollections";
    EventType[EventType["Cipher_ClientViewed"] = 1107] = "Cipher_ClientViewed";
    EventType[EventType["Cipher_ClientToggledPasswordVisible"] = 1108] = "Cipher_ClientToggledPasswordVisible";
    EventType[EventType["Cipher_ClientToggledHiddenFieldVisible"] = 1109] = "Cipher_ClientToggledHiddenFieldVisible";
    EventType[EventType["Cipher_ClientToggledCardCodeVisible"] = 1110] = "Cipher_ClientToggledCardCodeVisible";
    EventType[EventType["Cipher_ClientCopiedPassword"] = 1111] = "Cipher_ClientCopiedPassword";
    EventType[EventType["Cipher_ClientCopiedHiddenField"] = 1112] = "Cipher_ClientCopiedHiddenField";
    EventType[EventType["Cipher_ClientCopiedCardCode"] = 1113] = "Cipher_ClientCopiedCardCode";
    EventType[EventType["Cipher_ClientAutofilled"] = 1114] = "Cipher_ClientAutofilled";
    EventType[EventType["Cipher_SoftDeleted"] = 1115] = "Cipher_SoftDeleted";
    EventType[EventType["Cipher_Restored"] = 1116] = "Cipher_Restored";
    EventType[EventType["Cipher_ClientToggledCardNumberVisible"] = 1117] = "Cipher_ClientToggledCardNumberVisible";
    EventType[EventType["Cipher_ClientToggledTOTPSeedVisible"] = 1118] = "Cipher_ClientToggledTOTPSeedVisible";
    EventType[EventType["Collection_Created"] = 1300] = "Collection_Created";
    EventType[EventType["Collection_Updated"] = 1301] = "Collection_Updated";
    EventType[EventType["Collection_Deleted"] = 1302] = "Collection_Deleted";
    EventType[EventType["Group_Created"] = 1400] = "Group_Created";
    EventType[EventType["Group_Updated"] = 1401] = "Group_Updated";
    EventType[EventType["Group_Deleted"] = 1402] = "Group_Deleted";
    EventType[EventType["OrganizationUser_Invited"] = 1500] = "OrganizationUser_Invited";
    EventType[EventType["OrganizationUser_Confirmed"] = 1501] = "OrganizationUser_Confirmed";
    EventType[EventType["OrganizationUser_Updated"] = 1502] = "OrganizationUser_Updated";
    EventType[EventType["OrganizationUser_Removed"] = 1503] = "OrganizationUser_Removed";
    EventType[EventType["OrganizationUser_UpdatedGroups"] = 1504] = "OrganizationUser_UpdatedGroups";
    EventType[EventType["OrganizationUser_UnlinkedSso"] = 1505] = "OrganizationUser_UnlinkedSso";
    EventType[EventType["OrganizationUser_ResetPassword_Enroll"] = 1506] = "OrganizationUser_ResetPassword_Enroll";
    EventType[EventType["OrganizationUser_ResetPassword_Withdraw"] = 1507] = "OrganizationUser_ResetPassword_Withdraw";
    EventType[EventType["OrganizationUser_AdminResetPassword"] = 1508] = "OrganizationUser_AdminResetPassword";
    EventType[EventType["OrganizationUser_ResetSsoLink"] = 1509] = "OrganizationUser_ResetSsoLink";
    EventType[EventType["OrganizationUser_FirstSsoLogin"] = 1510] = "OrganizationUser_FirstSsoLogin";
    EventType[EventType["OrganizationUser_Revoked"] = 1511] = "OrganizationUser_Revoked";
    EventType[EventType["OrganizationUser_Restored"] = 1512] = "OrganizationUser_Restored";
    EventType[EventType["OrganizationUser_ApprovedAuthRequest"] = 1513] = "OrganizationUser_ApprovedAuthRequest";
    EventType[EventType["OrganizationUser_RejectedAuthRequest"] = 1514] = "OrganizationUser_RejectedAuthRequest";
    EventType[EventType["OrganizationUser_Deleted"] = 1515] = "OrganizationUser_Deleted";
    EventType[EventType["OrganizationUser_Left"] = 1516] = "OrganizationUser_Left";
    EventType[EventType["Organization_Updated"] = 1600] = "Organization_Updated";
    EventType[EventType["Organization_PurgedVault"] = 1601] = "Organization_PurgedVault";
    EventType[EventType["Organization_ClientExportedVault"] = 1602] = "Organization_ClientExportedVault";
    EventType[EventType["Organization_VaultAccessed"] = 1603] = "Organization_VaultAccessed";
    EventType[EventType["Organization_EnabledSso"] = 1604] = "Organization_EnabledSso";
    EventType[EventType["Organization_DisabledSso"] = 1605] = "Organization_DisabledSso";
    EventType[EventType["Organization_EnabledKeyConnector"] = 1606] = "Organization_EnabledKeyConnector";
    EventType[EventType["Organization_DisabledKeyConnector"] = 1607] = "Organization_DisabledKeyConnector";
    EventType[EventType["Organization_SponsorshipsSynced"] = 1608] = "Organization_SponsorshipsSynced";
    EventType[EventType["Organization_CollectionManagementUpdated"] = 1609] = "Organization_CollectionManagementUpdated";
    EventType[EventType["Policy_Updated"] = 1700] = "Policy_Updated";
    EventType[EventType["ProviderUser_Invited"] = 1800] = "ProviderUser_Invited";
    EventType[EventType["ProviderUser_Confirmed"] = 1801] = "ProviderUser_Confirmed";
    EventType[EventType["ProviderUser_Updated"] = 1802] = "ProviderUser_Updated";
    EventType[EventType["ProviderUser_Removed"] = 1803] = "ProviderUser_Removed";
    EventType[EventType["ProviderOrganization_Created"] = 1900] = "ProviderOrganization_Created";
    EventType[EventType["ProviderOrganization_Added"] = 1901] = "ProviderOrganization_Added";
    EventType[EventType["ProviderOrganization_Removed"] = 1902] = "ProviderOrganization_Removed";
    EventType[EventType["ProviderOrganization_VaultAccessed"] = 1903] = "ProviderOrganization_VaultAccessed";
    EventType[EventType["OrganizationDomain_Added"] = 2000] = "OrganizationDomain_Added";
    EventType[EventType["OrganizationDomain_Removed"] = 2001] = "OrganizationDomain_Removed";
    EventType[EventType["OrganizationDomain_Verified"] = 2002] = "OrganizationDomain_Verified";
    EventType[EventType["OrganizationDomain_NotVerified"] = 2003] = "OrganizationDomain_NotVerified";
    EventType[EventType["Secret_Retrieved"] = 2100] = "Secret_Retrieved";
})(EventType || (EventType = {}));

;// ../../libs/common/src/enums/http-status-code.enum.ts
var HttpStatusCode;
(function (HttpStatusCode) {
    HttpStatusCode[HttpStatusCode["Continue"] = 100] = "Continue";
    HttpStatusCode[HttpStatusCode["SwitchingProtocols"] = 101] = "SwitchingProtocols";
    HttpStatusCode[HttpStatusCode["Processing"] = 102] = "Processing";
    HttpStatusCode[HttpStatusCode["Ok"] = 200] = "Ok";
    HttpStatusCode[HttpStatusCode["Created"] = 201] = "Created";
    HttpStatusCode[HttpStatusCode["Accepted"] = 202] = "Accepted";
    HttpStatusCode[HttpStatusCode["NonAuthoritativeInformation"] = 203] = "NonAuthoritativeInformation";
    HttpStatusCode[HttpStatusCode["NoContent"] = 204] = "NoContent";
    HttpStatusCode[HttpStatusCode["ResetContent"] = 205] = "ResetContent";
    HttpStatusCode[HttpStatusCode["PartialContent"] = 206] = "PartialContent";
    HttpStatusCode[HttpStatusCode["MultiStatus"] = 207] = "MultiStatus";
    HttpStatusCode[HttpStatusCode["AlreadyReported"] = 208] = "AlreadyReported";
    HttpStatusCode[HttpStatusCode["ImUsed"] = 226] = "ImUsed";
    HttpStatusCode[HttpStatusCode["MultipleChoices"] = 300] = "MultipleChoices";
    HttpStatusCode[HttpStatusCode["MovedPermanently"] = 301] = "MovedPermanently";
    HttpStatusCode[HttpStatusCode["Found"] = 302] = "Found";
    HttpStatusCode[HttpStatusCode["SeeOther"] = 303] = "SeeOther";
    HttpStatusCode[HttpStatusCode["NotModified"] = 304] = "NotModified";
    HttpStatusCode[HttpStatusCode["UseProxy"] = 305] = "UseProxy";
    HttpStatusCode[HttpStatusCode["SwitchProxy"] = 306] = "SwitchProxy";
    HttpStatusCode[HttpStatusCode["TemporaryRedirect"] = 307] = "TemporaryRedirect";
    HttpStatusCode[HttpStatusCode["PermanentRedirect"] = 308] = "PermanentRedirect";
    HttpStatusCode[HttpStatusCode["BadRequest"] = 400] = "BadRequest";
    HttpStatusCode[HttpStatusCode["Unauthorized"] = 401] = "Unauthorized";
    HttpStatusCode[HttpStatusCode["PaymentRequired"] = 402] = "PaymentRequired";
    HttpStatusCode[HttpStatusCode["Forbidden"] = 403] = "Forbidden";
    HttpStatusCode[HttpStatusCode["NotFound"] = 404] = "NotFound";
    HttpStatusCode[HttpStatusCode["MethodNotAllowed"] = 405] = "MethodNotAllowed";
    HttpStatusCode[HttpStatusCode["NotAcceptable"] = 406] = "NotAcceptable";
    HttpStatusCode[HttpStatusCode["ProxyAuthenticationRequired"] = 407] = "ProxyAuthenticationRequired";
    HttpStatusCode[HttpStatusCode["RequestTimeout"] = 408] = "RequestTimeout";
    HttpStatusCode[HttpStatusCode["Conflict"] = 409] = "Conflict";
    HttpStatusCode[HttpStatusCode["Gone"] = 410] = "Gone";
    HttpStatusCode[HttpStatusCode["LengthRequired"] = 411] = "LengthRequired";
    HttpStatusCode[HttpStatusCode["PreconditionFailed"] = 412] = "PreconditionFailed";
    HttpStatusCode[HttpStatusCode["PayloadTooLarge"] = 413] = "PayloadTooLarge";
    HttpStatusCode[HttpStatusCode["UriTooLong"] = 414] = "UriTooLong";
    HttpStatusCode[HttpStatusCode["UnsupportedMediaType"] = 415] = "UnsupportedMediaType";
    HttpStatusCode[HttpStatusCode["RangeNotSatisfiable"] = 416] = "RangeNotSatisfiable";
    HttpStatusCode[HttpStatusCode["ExpectationFailed"] = 417] = "ExpectationFailed";
    HttpStatusCode[HttpStatusCode["IAmATeapot"] = 418] = "IAmATeapot";
    HttpStatusCode[HttpStatusCode["MisdirectedRequest"] = 421] = "MisdirectedRequest";
    HttpStatusCode[HttpStatusCode["UnprocessableEntity"] = 422] = "UnprocessableEntity";
    HttpStatusCode[HttpStatusCode["Locked"] = 423] = "Locked";
    HttpStatusCode[HttpStatusCode["FailedDependency"] = 424] = "FailedDependency";
    HttpStatusCode[HttpStatusCode["UpgradeRequired"] = 426] = "UpgradeRequired";
    HttpStatusCode[HttpStatusCode["PreconditionRequired"] = 428] = "PreconditionRequired";
    HttpStatusCode[HttpStatusCode["TooManyRequests"] = 429] = "TooManyRequests";
    HttpStatusCode[HttpStatusCode["RequestHeaderFieldsTooLarge"] = 431] = "RequestHeaderFieldsTooLarge";
    HttpStatusCode[HttpStatusCode["UnavailableForLegalReasons"] = 451] = "UnavailableForLegalReasons";
    HttpStatusCode[HttpStatusCode["InternalServerError"] = 500] = "InternalServerError";
    HttpStatusCode[HttpStatusCode["NotImplemented"] = 501] = "NotImplemented";
    HttpStatusCode[HttpStatusCode["BadGateway"] = 502] = "BadGateway";
    HttpStatusCode[HttpStatusCode["ServiceUnavailable"] = 503] = "ServiceUnavailable";
    HttpStatusCode[HttpStatusCode["GatewayTimeout"] = 504] = "GatewayTimeout";
    HttpStatusCode[HttpStatusCode["HttpVersionNotSupported"] = 505] = "HttpVersionNotSupported";
    HttpStatusCode[HttpStatusCode["VariantAlsoNegotiates"] = 506] = "VariantAlsoNegotiates";
    HttpStatusCode[HttpStatusCode["InsufficientStorage"] = 507] = "InsufficientStorage";
    HttpStatusCode[HttpStatusCode["LoopDetected"] = 508] = "LoopDetected";
    HttpStatusCode[HttpStatusCode["NotExtended"] = 510] = "NotExtended";
    HttpStatusCode[HttpStatusCode["NetworkAuthenticationRequired"] = 511] = "NetworkAuthenticationRequired";
})(HttpStatusCode || (HttpStatusCode = {}));

;// ../../libs/common/src/enums/integration-type.enum.ts
var IntegrationType;
(function (IntegrationType) {
    IntegrationType["Integration"] = "integration";
    IntegrationType["SDK"] = "sdk";
})(IntegrationType || (IntegrationType = {}));

;// ../../libs/common/src/enums/native-messaging-version.enum.ts
var NativeMessagingVersion;
(function (NativeMessagingVersion) {
    NativeMessagingVersion[NativeMessagingVersion["One"] = 1] = "One";
    NativeMessagingVersion[NativeMessagingVersion["Latest"] = 1] = "Latest";
})(NativeMessagingVersion || (NativeMessagingVersion = {}));

;// ../../libs/common/src/enums/notification-type.enum.ts
var NotificationType;
(function (NotificationType) {
    NotificationType[NotificationType["SyncCipherUpdate"] = 0] = "SyncCipherUpdate";
    NotificationType[NotificationType["SyncCipherCreate"] = 1] = "SyncCipherCreate";
    NotificationType[NotificationType["SyncLoginDelete"] = 2] = "SyncLoginDelete";
    NotificationType[NotificationType["SyncFolderDelete"] = 3] = "SyncFolderDelete";
    NotificationType[NotificationType["SyncCiphers"] = 4] = "SyncCiphers";
    NotificationType[NotificationType["SyncVault"] = 5] = "SyncVault";
    NotificationType[NotificationType["SyncOrgKeys"] = 6] = "SyncOrgKeys";
    NotificationType[NotificationType["SyncFolderCreate"] = 7] = "SyncFolderCreate";
    NotificationType[NotificationType["SyncFolderUpdate"] = 8] = "SyncFolderUpdate";
    NotificationType[NotificationType["SyncCipherDelete"] = 9] = "SyncCipherDelete";
    NotificationType[NotificationType["SyncSettings"] = 10] = "SyncSettings";
    NotificationType[NotificationType["LogOut"] = 11] = "LogOut";
    NotificationType[NotificationType["SyncSendCreate"] = 12] = "SyncSendCreate";
    NotificationType[NotificationType["SyncSendUpdate"] = 13] = "SyncSendUpdate";
    NotificationType[NotificationType["SyncSendDelete"] = 14] = "SyncSendDelete";
    NotificationType[NotificationType["AuthRequest"] = 15] = "AuthRequest";
    NotificationType[NotificationType["AuthRequestResponse"] = 16] = "AuthRequestResponse";
    NotificationType[NotificationType["SyncOrganizations"] = 17] = "SyncOrganizations";
})(NotificationType || (NotificationType = {}));

;// ../../libs/common/src/enums/index.ts









;// ./src/utils.ts
function invokeMenu(menu) {
    const menuWithoutClick = menu.map((m) => {
        return { label: m.label, type: m.type };
    });
    ipc.platform.openContextMenu(menuWithoutClick).then((i) => {
        if (i !== -1) {
            menu[i].click();
        }
    });
}
function isDev() {
    if ("ELECTRON_IS_DEV" in process.env) {
        return parseInt(process.env.ELECTRON_IS_DEV, 10) === 1;
    }
    return process.defaultApp || /node_modules[\\/]electron[\\/]/.test(process.execPath);
}
function isLinux() {
    return process.platform === "linux";
}
function isAppImage() {
    return isLinux() && "APPIMAGE" in process.env;
}
function isSnapStore() {
    return isLinux() && process.env.SNAP_USER_DATA != null;
}
function isMac() {
    return process.platform === "darwin";
}
function isMacAppStore() {
    return isMac() && process.mas === true;
}
function isWindows() {
    return process.platform === "win32";
}
function isWindowsStore() {
    var _a;
    const windows = isWindows();
    let windowsStore = process.windowsStore;
    if (windows &&
        !windowsStore &&
        ((_a = process.resourcesPath) === null || _a === void 0 ? void 0 : _a.indexOf("8bitSolutionsLLC.bitwardendesktop_")) > -1) {
        windowsStore = true;
    }
    return windows && windowsStore === true;
}
function isFlatpak() {
    return process.platform === "linux" && process.env.container != null;
}
function isWindowsPortable() {
    return isWindows() && process.env.PORTABLE_EXECUTABLE_DIR != null;
}
function cleanUserAgent(userAgent) {
    const userAgentItem = (startString, endString) => {
        const startIndex = userAgent.indexOf(startString);
        return userAgent.substring(startIndex, userAgent.indexOf(endString, startIndex) + 1);
    };
    const systemInformation = "(Windows NT 10.0; Win64; x64)";
    return userAgent
        .replace(userAgentItem("(", ")"), systemInformation)
        .replace(userAgentItem("Bitwarden", " "), "")
        .replace(userAgentItem("Electron", " "), "");
}

;// ./src/platform/preload.ts
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};



const storage = {
    get: (key) => external_electron_namespaceObject.ipcRenderer.invoke("storageService", { action: "get", key }),
    has: (key) => external_electron_namespaceObject.ipcRenderer.invoke("storageService", { action: "has", key }),
    save: (key, obj) => external_electron_namespaceObject.ipcRenderer.invoke("storageService", { action: "save", key, obj }),
    remove: (key) => external_electron_namespaceObject.ipcRenderer.invoke("storageService", { action: "remove", key }),
};
const passwords = {
    get: (key, keySuffix) => external_electron_namespaceObject.ipcRenderer.invoke("keytar", { action: "getPassword", key, keySuffix }),
    has: (key, keySuffix) => external_electron_namespaceObject.ipcRenderer.invoke("keytar", { action: "hasPassword", key, keySuffix }),
    set: (key, keySuffix, value) => external_electron_namespaceObject.ipcRenderer.invoke("keytar", { action: "setPassword", key, keySuffix, value }),
    delete: (key, keySuffix) => external_electron_namespaceObject.ipcRenderer.invoke("keytar", { action: "deletePassword", key, keySuffix }),
};
const clipboard = {
    read: () => external_electron_namespaceObject.ipcRenderer.invoke("clipboard.read"),
    write: (message) => external_electron_namespaceObject.ipcRenderer.invoke("clipboard.write", message),
};
const sshAgent = {
    init: () => __awaiter(void 0, void 0, void 0, function* () {
        yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.init");
    }),
    setKeys: (keys) => external_electron_namespaceObject.ipcRenderer.invoke("sshagent.setkeys", keys),
    signRequestResponse: (requestId, accepted) => __awaiter(void 0, void 0, void 0, function* () {
        yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.signrequestresponse", { requestId, accepted });
    }),
    generateKey: (keyAlgorithm) => __awaiter(void 0, void 0, void 0, function* () {
        return yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.generatekey", { keyAlgorithm });
    }),
    lock: () => __awaiter(void 0, void 0, void 0, function* () {
        return yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.lock");
    }),
    clearKeys: () => __awaiter(void 0, void 0, void 0, function* () {
        return yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.clearkeys");
    }),
    importKey: (key, password) => __awaiter(void 0, void 0, void 0, function* () {
        const res = yield external_electron_namespaceObject.ipcRenderer.invoke("sshagent.importkey", {
            privateKey: key,
            password: password,
        });
        return res;
    }),
};
const powermonitor = {
    isLockMonitorAvailable: () => external_electron_namespaceObject.ipcRenderer.invoke("powermonitor.isLockMonitorAvailable"),
};
const nativeMessaging = {
    sendReply: (message) => {
        external_electron_namespaceObject.ipcRenderer.send("nativeMessagingReply", message);
    },
    sendMessage: (message) => {
        external_electron_namespaceObject.ipcRenderer.send("nativeMessagingReply", message);
    },
    onMessage: (callback) => {
        external_electron_namespaceObject.ipcRenderer.on("nativeMessaging", (_event, message) => callback(message));
    },
    manifests: {
        generate: (create) => external_electron_namespaceObject.ipcRenderer.invoke("nativeMessaging.manifests", { create }),
        generateDuckDuckGo: (create) => external_electron_namespaceObject.ipcRenderer.invoke("nativeMessaging.ddgManifests", { create }),
    },
};
const preload_crypto = {
    argon2: (password, salt, iterations, memory, parallelism) => external_electron_namespaceObject.ipcRenderer.invoke("crypto.argon2", { password, salt, iterations, memory, parallelism }),
};
const ephemeralStore = {
    setEphemeralValue: (key, value) => external_electron_namespaceObject.ipcRenderer.invoke("setEphemeralValue", { key, value }),
    getEphemeralValue: (key) => external_electron_namespaceObject.ipcRenderer.invoke("getEphemeralValue", key),
    removeEphemeralValue: (key) => external_electron_namespaceObject.ipcRenderer.invoke("deleteEphemeralValue", key),
};
const localhostCallbackService = {
    openSsoPrompt: (codeChallenge, state) => {
        return external_electron_namespaceObject.ipcRenderer.invoke("openSsoPrompt", { codeChallenge, state });
    },
};
/* harmony default export */ const platform_preload = ({
    versions: {
        app: () => external_electron_namespaceObject.ipcRenderer.invoke("appVersion"),
        registerSdkVersionProvider: (provide) => {
            const resolve = (version) => external_electron_namespaceObject.ipcRenderer.send("sdkVersion", version);
            external_electron_namespaceObject.ipcRenderer.on("sdkVersion", () => {
                provide(resolve);
            });
        },
    },
    deviceType: deviceType(),
    isDev: isDev(),
    isMacAppStore: isMacAppStore(),
    isWindowsStore: isWindowsStore(),
    isFlatpak: isFlatpak(),
    isSnapStore: isSnapStore(),
    isAppImage: isAppImage(),
    reloadProcess: () => external_electron_namespaceObject.ipcRenderer.send("reload-process"),
    focusWindow: () => external_electron_namespaceObject.ipcRenderer.send("window-focus"),
    hideWindow: () => external_electron_namespaceObject.ipcRenderer.send("window-hide"),
    log: (level, message, ...optionalParams) => external_electron_namespaceObject.ipcRenderer.invoke("ipc.log", { level, message, optionalParams }),
    openContextMenu: (menu) => external_electron_namespaceObject.ipcRenderer.invoke("openContextMenu", { menu }),
    getSystemTheme: () => external_electron_namespaceObject.ipcRenderer.invoke("systemTheme"),
    onSystemThemeUpdated: (callback) => {
        external_electron_namespaceObject.ipcRenderer.on("systemThemeUpdated", (_event, theme) => callback(theme));
    },
    isWindowVisible: () => external_electron_namespaceObject.ipcRenderer.invoke("windowVisible"),
    getLanguageFile: (formattedLocale) => external_electron_namespaceObject.ipcRenderer.invoke("getLanguageFile", formattedLocale),
    sendMessage: (message) => external_electron_namespaceObject.ipcRenderer.send("messagingService", message),
    onMessage: {
        addListener: (callback) => {
            external_electron_namespaceObject.ipcRenderer.addListener("messagingService", (_event, message) => {
                if (message.command) {
                    callback(message);
                }
            });
        },
        removeListener: (callback) => {
            external_electron_namespaceObject.ipcRenderer.removeListener("messagingService", (_event, message) => {
                if (message.command) {
                    callback(message);
                }
            });
        },
    },
    launchUri: (uri) => external_electron_namespaceObject.ipcRenderer.invoke("launchUri", uri),
    storage,
    passwords,
    clipboard,
    sshAgent,
    powermonitor,
    nativeMessaging,
    crypto: preload_crypto,
    ephemeralStore,
    localhostCallbackService,
});
function deviceType() {
    switch (process.platform) {
        case "win32":
            return DeviceType.WindowsDesktop;
        case "darwin":
            return DeviceType.MacOsDesktop;
        default:
            return DeviceType.LinuxDesktop;
    }
}

;// ./src/preload.ts




const preload_ipc = {
    auth: preload,
    platform: platform_preload,
    keyManagement: key_management_preload,
};
external_electron_namespaceObject.contextBridge.exposeInMainWorld("ipc", preload_ipc);

/******/ })()
;